unit Unit1;
{*****************************************************************************}
{    F.A.Q Delphi - www.developpez.com                                        }
{                                                                             }
{ Redimensionnement d'un JPG                                                  }
{ Auteurs : Nut62,Nono40                                                      }
{                                                                             }
{ Ralis avec Delphi 7                                                       }
{*****************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Ouvrir: TOpenDialog;
    Sauver: TSaveDialog;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Label2MouseEnter(Sender: TObject);
    procedure Label2MouseLeave(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Uses JPeg,Resample,ShellApi;

Const Coeff = 80;

procedure TForm1.Button1Click(Sender: TObject);
Var jpg :TJpegImage;
    Bmp, Bmp2 :TBitMap;
Begin

  // Slection de l'image
  If Not Ouvrir.Execute Then Exit;
  // Slection du nom de destination
  If Not Sauver.Execute Then Exit;

  // Cration des variables temporaires
  Jpg := TJpegImage.Create;
  Bmp := TBitMap   .Create;
  Bmp2 := TBitMap   .Create;
  Try
    // Lecture de l'image
    Jpg.LoadFromFile(Ouvrir.FileName);
    // Le BitMap est adpapt  la taille voulue

    // Convertion du jpg en Bmp
    Bmp2.Width  := Jpg.Width  ;
    Bmp2.Height := Jpg.Height ;
    Bmp2.PixelFormat:=pf24bit;
    bmp2.Canvas.Draw(0,0,jpg);

    // On prpare le bmp cible
    Bmp.Width  := Jpg.Width  * coeff Div 100;
    Bmp.Height := Jpg.Height * coeff Div 100;
    Bmp.PixelFormat:=pf24bit;

    //stretch
    ImgStretch(Bmp2, Bmp,ResampleFilters[5].Filter, ResampleFilters[5].Width);
    //convertion en jpg et enregistrement
    Jpg.Assign(Bmp);
    Jpg.SaveToFile(Sauver.FileName);
  Finally
    // libration des ressources
    Jpg .Free;
    Bmp .Free;
    Bmp2.Free;
  End;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Var jpg :TJpegImage;
    Bmp :TBitMap;
Begin
  // Slection de l'image
  If Not Ouvrir.Execute Then Exit;
  // Slection du nom de destination
  If Not Sauver.Execute Then Exit; 

  // Cration des variables temporaires 
  Jpg := TJpegImage.Create; 
  Bmp := TBitMap   .Create; 
  Try 
    // Lecture de l'image 
    Jpg.LoadFromFile(Ouvrir.FileName);
    // Le BitMap est adpapt  la taille voulue
    Bmp.Width  :=Jpg.Width  * Coeff Div 100;
    Bmp.Height :=Jpg.Height * Coeff Div 100;
    // L'image est dessine dans la totalit de la surface du BitMap
    Bmp.Canvas.StretchDraw(Bmp.Canvas.ClipRect,Jpg);
    // Puis la nouvelle image est assigne au JPG
    Jpg.Assign(Bmp);
    // et enfin elle est enregistre
    Jpg.SaveToFile(Sauver.FileName);
  Finally
    // libration des ressources
    Jpg .Free;
    Bmp .Free;
  End;
End;

procedure TForm1.Label2Click(Sender: TObject);
begin
  ShellExecute(Handle,'OPEN','http://delphi.developpez.com',nil,nil,SW_SHOWNORMAL);
end;

procedure TForm1.Label2MouseEnter(Sender: TObject);
begin
  Label2.Font.Style:=[fsUnderline,fsBold];
end;

procedure TForm1.Label2MouseLeave(Sender: TObject);
begin
  Label2.Font.Style:=[fsBold];
end;

end.
